; 
    include \masm32\include\masm32rt.inc
    .686
    .mmx
    include \masm32\macros\timers.asm
; 
    .data
      counts dd 100 dup(0)
      seed   dw 31415
    .code
; 

align 4
ddr proc
    push ebx
    mov ax,seed ;seed
    mov ebx,56789
    mov edx,263
    movd MM0,eax
    movd MM1,ebx
    movd MM2,edx
    pmullw MM0,MM2
    paddw MM0,MM1
    movd eax,MM0 ;new seed
    mov seed,ax
    pop ebx
    ret
ddr endp

; 

ddrb proc base:DWORD

    push ebx
    mov ax,seed ;seed
    mov ebx,56789
    mov edx,263
    movd MM0,eax
    movd MM1,ebx
    movd MM2,edx
    pmullw MM0,MM2
    paddw MM0,MM1
    movd eax,MM0 ;new seed
    mov seed,ax

    xor edx, edx
    div base
    mov eax, edx

    pop ebx
    ret
ddrb endp

; 
start:
; 

    ;----------------------
    ; A quick visual test.
    ;----------------------

    mov ebx, 1000
    .WHILE ebx
      call ddr
      print uhex$(eax),9
      dec ebx
    .ENDW

    print chr$(13,10)
    inkey
    print chr$(13,10)

    ;-----------------------------------
    ; A quick test of the distribution.
    ;-----------------------------------

    mov ebx, 10000000
    .WHILE ebx
      invoke ddrb, 10
      inc DWORD PTR counts[eax*4]
      dec ebx
    .ENDW
    D=0
    REPEAT 10
      print ustr$(counts+D),13,10
      D=D+4
    ENDM

    print chr$(13,10)
    inkey
    print chr$(13,10)

    invoke memfill, ADDR counts, 400, 0

    mov ebx, 10000000
    .WHILE ebx
      invoke ddrb, 100
      inc DWORD PTR counts[eax*4]
      dec ebx
    .ENDW
    D=0
    REPEAT 100
      print ustr$(counts+D),13,10
      D=D+4
    ENDM

    print chr$(13,10)
    inkey
    print chr$(13,10)

    invoke Sleep, 3000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      call ddr
    counter_end
    print ustr$(eax)," cycles",13,10,13,10

    inkey "Press any key to exit..."
    exit
; 
end start
